# Credits licensing for media files in `mobs_mc`

## Licenses used

The following media licenses are used:

* [CC0](https://creativecommons.org/choose/zero/)
* [CC BY 3.0](https://creativecommons.org/licenses/by/3.0/)
* [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/)
* [GPL v3](https://www.gnu.org/licenses/gpl-3.0.html])
* [MIT License](https://opensource.org/licenses/MIT)
* [LGPL v2.1](https://www.gnu.org/licenses/lgpl-2.1.html)

Note: A “`*`” in a file name below is a placeholder which can stand for any text.

## Models
All models were done by [22i](https://github.com/22i) and are licensed under GPLv3.

Origin of those models:

* [Mod “amc”](https://github.com/22i/amc/)
* [Repository with Blender source files for models](https://github.com/22i/minecraft-voxel-blender-models)

## Textures

* Mob and item textures are heavily based on [Pixel Perfection](https://www.planetminecraft.com/texture_pack/131pixel-perfection/), a texture pack for Minecraft.
    * Original author: [XSSheep](https://www.planetminecraft.com/member/xssheep/)
    * License (if not mentioned otherwise): CC BY-SA 4.0
    * Some textures have been modified or added
    * Modifications and additions by MysticTempest:
        * `mobs_mc_cave_spider.png`
        * `mobs_mc_enderman_eyes.png`
        * `mobs_mc_enderman.png`
        * `mobs_mc_ghast.png`
        * `mobs_mc_skeleton.png`
        * `mobs_mc_slime.png`
        * `mobs_mc_spider_eyes.png`
        * `mobs_mc_spider.png`
        * `mobs_mc_squid.png`
        * `mobs_mc_zombie.png`
        * `mobs_mc_villager_butcher.png`
        * `mobs_mc_villager_farmer.png`
        * `mobs_mc_villager_librarian.png`
        * `mobs_mc_villager.png`
        * `mobs_mc_villager_priest.png`
        * `mobs_mc_villager_smith.png`
        * `mobs_mc_parrot_blue.png`
        * `mobs_mc_parrot_green.png`
        * `mobs_mc_parrot_grey.png`
        * `mobs_mc_parrot_red_blue.png`
        * `mobs_mc_parrot_yellow_blue.png`
        * `mobs_mc_evoker_base.png` (modified by kingoscargames)
        * `mobs_mc_illusionist_bow.png`
        * `mobs_mc_illusionist.png`
        * `mobs_mc_vindicator_axe.png`
        * `mobs_mc_vindicator_base.png`
        * `mobs_mc_horse_skeleton.png`
    * Additions by kingoscargames:
        * `mobs_mc_vex.png`
        * `mobs_mc_vex_charging.png`
        * `mobs_mc_llama.png`
        * `mobs_mc_llama_creamy.png`
        * `mobs_mc_llama_brown.png`
        * `mobs_mc_llama_white.png`
        * `mobs_mc_llama_gray.png`
        * `mobs_mc_llama_chest.png`
        * `mobs_mc_endermite.png`
        * `mobs_mc_magmacube.png`
        * `mobs_mc_chicken.png`
        * `mobs_mc_wither.png`
        * `mobs_mc_wither_skeleton.png`
        * `mobs_mc_TEMP_wither_projectile.png`	

* “Spawn egg” textures (`mobs_mc_spawn_icon_*`) by 22i
* Any other texture not mentioned here are licensed under the MIT License

## Sounds

* PilzAdam and Wuzzy (CC0)
    * `mobs_mc_chicken_lay_egg.ogg`
* Randomation (CC0)
    * `green_slime_damage.ogg`
    * `green_slime_attack.ogg`
        * Source: <http://www.freesound.org/people/RandomationPictures/sounds/138481/>
* [Dr. Minky](http://www.freesound.org/people/DrMinky/sounds/) (CC BY 3.0)
    * `green_slime_jump.ogg`
    * `green_slime_land.ogg`
    * `green_slime_death.ogg`
* Zozzy from Freesound.org (CC0)
    * `mobs_mc_cow.ogg`
        * Source: <https://www.freesound.org/people/Zozzy/sounds/59245/>
* [NPXcoot](https://github.com/NPXcoot1) (CC BY-SA 4.0)
    * `mobs_mc_ender_dragon_*`
* Blender Foundation (CC BY 3.0)
    * `mobs_sheep.ogg`,
* daufinsyd (MIT License)
    * `mobs_mc_blaze_breath.ogg`
    * `mobs_mc_blaze_died.ogg`
    * `mobs_mc_squid_hurt.ogg`
* [thefilmbakery](https://freesound.org/people/thefilmbakery/) (CC0)
    * `mobs_mc_blaze_hurt.ogg`
	* Source: <https://freesound.org/people/thefilmbakery/sounds/137836/>
* TenPlus1, from `mobs_monster` or `mobs_animal` mod (MIT License)
    * `mobs_chicken.ogg`
    * `mobs_fireball.ogg`
    * `mobs_kitten.ogg`
    * `mobs_mc_llama.ogg`
    * `mobs_pig.ogg`
    * `mobs_pig_angry.ogg`
    * `mobs_rat.ogg`
    * `mobs_sandmonster.ogg`
    * `mobs_spider.ogg`
* BrandonReese (LGPL v2.1)
    * `mobs_eerie.ogg`
* [Under7dude](https://freesound.org/people/Under7dude/) (CC0)
    * `mobs_mc_zombie_idle.ogg`
        * Source: <https://freesound.org/people/Under7dude/sounds/163445/>
* [haratman](https://freesound.org/people/haratman/) (CC0)
    * `mobs_mc_zombie_death.ogg`
        * Source: <https://freesound.org/people/haratman/sounds/393749/>
    * `mobs_mc_zombie_hurt.ogg`
        * Source: <https://freesound.org/people/haratman/sounds/393749/>
* [Spennnyyy](https://freesound.org/people/Spennnyyy/) (CC0)
    * `mcl_totems_totem.ogg`
        * Source: <https://freesound.org/people/Spennnyyy/sounds/323502/>
